
/* Chrysalide - Outil d'analyse de fichiers binaires
 * vm.h - prototypes pour la constitution des charges utiles liées à la VM
 *
 * Copyright (C) 2010-2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DEBUG_JDWP_SETS_VM_H
#define _DEBUG_JDWP_SETS_VM_H


#include <stdbool.h>


#include "../jdwp_def.h"
#include "../../../arch/archbase.h"



/* Reconstitue une réponse quant à une version de serveur. */
bool get_jdwp_vm_version(const bin_t *, off_t, const jdwp_cmd_vm_id_sizes_reply *, jdwp_cmd_vm_version_reply *);

/* Libère le contenu d'une réponse quant à une version. */
void free_jdwp_vm_version(jdwp_cmd_vm_version_reply *);

/* Reconstitue une réponse fournissant la liste des threads. */
bool get_jdwp_vm_all_threads(const bin_t *, off_t, const jdwp_cmd_vm_id_sizes_reply *, jdwp_cmd_vm_allthreads_reply *);

/* Libère le contenu d'une réponse offrant une liste de threads. */
void free_jdwp_all_threads(jdwp_cmd_vm_allthreads_reply *);

/* Reconstitue une réponse quant aux tailles spécifiques. */
bool get_jdwp_vm_id_sizes(const bin_t *, off_t, const jdwp_cmd_vm_id_sizes_reply *, jdwp_cmd_vm_id_sizes_reply *);



#endif  /* _DEBUG_JDWP_SETS_VM_H */
