
/* Chrysalide - Outil d'analyse de fichiers binaires
 * call.h - prototypes pour l'encadrement des appels de routine
 *
 * Copyright (C) 2010-2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_CALL_H
#define _DECOMP_EXPR_CALL_H


#include <glib-object.h>


#include "../expression.h"
#include "../instruction.h"
#include "../../analysis/routine.h"



#define G_TYPE_ROUTINE_CALL               g_routine_call_get_type()
#define G_ROUTINE_CALL(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_routine_call_get_type(), GRoutineCall))
#define G_IS_ROUTINE_CALL(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_routine_call_get_type()))
#define G_ROUTINE_CALL_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_ROUTINE_CALL, GRoutineCallClass))
#define G_IS_ROUTINE_CALL_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_ROUTINE_CALL))
#define G_ROUTINE_CALL_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_ROUTINE_CALL, GRoutineCallClass))



/* Définition d'un appel à une routine quelconque (instance) */
typedef struct _GRoutineCall GRoutineCall;

/* Définition d'un appel à une routine quelconque (classe) */
typedef struct _GRoutineCallClass GRoutineCallClass;


/* Indique le type défini pour un appel à une routine quelconque. */
GType g_routine_call_get_type(void);

/* Exprime un appel à une routine quelconque. */
GDecInstruction *g_routine_call_new(GBinRoutine *);

/* Enregistre un nouvel argument pour l'appel de routine. */
void g_routine_call_add_arg(GRoutineCall *, GDecInstruction *);



#endif  /* _DECOMP_EXPR_CALL_H */
